diff --git a/lib/hive/commands/setup.rb b/lib/hive/commands/setup.rb
new file mode 100644
index 00000000..ceea71f5
--- /dev/null
+++ b/lib/hive/commands/setup.rb
@@ -0,0 +1,317 @@
+require "fileutils"
+require "json"
+require "stringio"
+require "hive"
+require "hive/config"
+require "hive/invoked_binary"
+require "hive/paths"
+require "hive/setup/diagnostics"
+require "hive/web/environment"
+
+module Hive
+  module Commands
+    class Setup
+      PHASE_REMEDIATIONS = {
+        "diagnostics" => [ "Fix the failed prerequisites above, then run `hive setup` again." ],
+        "qmd" => [ "Install qmd with `npm install --global @tobilu/qmd`, then run `hive setup` again." ],
+        "web_bundle" => [ "Run `hive web install` to retry the authenticated web bundle installation." ],
+        "daemon_service" => [ "Run `hive daemon install --force`, then inspect `hive daemon status --json`." ],
+        "daemon_readiness" => [ "Run `hive daemon status --json`, fix the reported condition, then rerun `hive setup`." ],
+        "repository_enrollment" => [ "Run `hive init` in the repository, then rerun `hive setup`." ],
+        "web_service" => [ "Run `hive web install`, then inspect `hive web status --json`." ],
+        "web_readiness" => [ "Run `hive web status --json`, fix the reported condition, then rerun `hive setup`." ],
+        "setup" => [ "Rerun `hive setup`; if it still fails, inspect the preceding phase and diagnostic output." ]
+      }.freeze
+
+      FOREGROUND_COMMAND = "hive daemon start --detach && hive web".freeze
+
+      def initialize(project_root: Dir.pwd, no_bootstrap: false, no_init: false,
+                     no_service: false, json: false, output: $stdout,
+                     diagnostics: nil, qmd_bootstrap: nil, bundle_installer: nil,
+                     daemon_installer: nil, daemon_status: nil, enroller: nil,
+                     web_installer: nil, web_status: nil, binary: nil)
+        @project_root = File.expand_path(project_root)
+        @no_bootstrap = no_bootstrap
+        @no_init = no_init
+        @no_service = no_service
+        @json = json
+        @output = output
+        @binary = binary || Hive::InvokedBinary.path || File.expand_path("../../../bin/hive", __dir__)
+        @diagnostics = diagnostics || Hive::Setup::Diagnostics.new
+        @qmd_bootstrap = qmd_bootstrap || -> { bootstrap_qmd }
+        @bundle_installer = bundle_installer || -> { install_bundle }
+        @daemon_installer = daemon_installer || ->(path) { install_daemon(path) }
+        @daemon_status = daemon_status || ->(path) { daemon_report(path) }
+        @enroller = enroller || -> { enroll_repository }
+        @web_installer = web_installer || ->(path) { install_web(path) }
+        @web_status = web_status || -> { web_report }
+        @phases = []
+        @phase_values = {}
+      end
+
+      def call
+        checks = @diagnostics.call
+        if blocking_checks(checks).any?
+          remediation = blocking_checks(checks).flat_map do |check|
+            check.respond_to?(:remediation) ? Array(check.remediation) : []
+          end.compact.uniq
+          phase("diagnostics", false, "mandatory prerequisites are not ready", remediation: remediation)
+          return finish(checks, nil)
+        end
+        phase("diagnostics", true, "supported platform and operator-owned prerequisites are ready")
+
+        qmd = checks.find { |check| check.name == "qmd" }
+        if qmd && !qmd.success? && !run_phase("qmd", &@qmd_bootstrap)
+          return finish(checks, nil)
+        end
+        return finish(checks, nil) unless run_phase("web_bundle", &@bundle_installer)
+        return finish(checks, nil) unless run_phase("daemon_service") { @daemon_installer.call(@binary) }
+
+        daemon_fallback = service_fallback?(@phase_values["daemon_service"])
+        if daemon_fallback
+          phase(
+            "daemon_readiness",
+            true,
+            "service manager unavailable; foreground daemon will be required"
+          )
+        else
+          return finish(checks, nil) unless run_phase("daemon_readiness") do
+            @daemon_status.call(@binary)["ready"] == true
+          end
+        end
+        return finish(checks, nil) unless @no_init || run_phase("repository_enrollment", &@enroller)
+
+        url = Hive::Web::Environment.new(config: Hive::Config.load_global_web).url
+        if @no_service
+          phase("web_service", true, "skipped by --no-service; run `hive web` in the foreground")
+          @output.puts "hive setup: foreground web is ready to run: hive web" unless @json
+          return finish(checks, url)
+        end
+
+        if daemon_fallback
+          phase(
+            "web_service",
+            false,
+            "service manager unavailable; managed services were not accepted",
+            remediation: [ "Run `#{FOREGROUND_COMMAND}`." ]
+          )
+          @output.puts "hive setup: autostart unavailable; run: #{FOREGROUND_COMMAND}" unless @json
+          return finish(checks, url)
+        end
+
+        return finish(checks, nil) unless run_phase("web_service") { @web_installer.call(@binary) }
+        if service_fallback?(@phase_values["web_service"])
+          phase(
+            "web_readiness",
+            false,
+            "web autostart unavailable; foreground web is required",
+            remediation: [ "Run `hive web`." ]
+          )
+          @output.puts "hive setup: web autostart unavailable; run: hive web" unless @json
+          return finish(checks, url)
+        end
+        return finish(checks, nil) unless run_phase("web_readiness") do
+          status = @web_status.call
+          url = status["url"] if status["url"]
+          status["ready"] == true
+        end
+        finish(checks, url)
+      rescue StandardError => e
+        phase("setup", false, "#{e.class}: #{e.message}")
+        finish([], nil)
+      end
+
+      private
+
+      def blocking_checks(checks)
+        checks.select do |check|
+          next false if check.success?
+
+          @no_bootstrap || !check.bootstrappable
+        end
+      end
+
+      def run_phase(name)
+        value = yield
+        @phase_values[name] = value
+        ok = value != false && (!value.respond_to?(:success?) || value.success?)
+        phase(name, ok, ok ? "complete" : "failed")
+        ok
+      rescue StandardError => e
+        phase(name, false, "#{e.class}: #{e.message}")
+        false
+      end
+
+      def phase(name, ok, message, remediation: nil)
+        fixes = if ok
+          []
+        else
+          supplied = Array(remediation).reject(&:empty?)
+          supplied.empty? ? PHASE_REMEDIATIONS.fetch(name, PHASE_REMEDIATIONS["setup"]) : supplied
+        end
+        @phases << {
+          "name" => name,
+          "ok" => ok,
+          "message" => message,
+          "remediation" => fixes
+        }
+      end
+
+      def finish(checks, url)
+        ok = @phases.all? { |entry| entry["ok"] }
+        payload = {
+          "schema" => "hive-setup",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-setup"),
+          "ok" => ok,
+          "checks" => checks.map(&:to_h),
+          "phases" => @phases,
+          "url" => url
+        }
+        if @json
+          @output.puts JSON.generate(payload)
+        else
+          @phases.each do |entry|
+            icon = entry["ok"] ? "✓" : "✗"
+            @output.puts "  #{icon} #{entry['name']}: #{entry['message']}"
+          end
+          @output.puts("hive setup: ready at #{url}") if ok && url && !@no_service
+          unless ok
+            @phases.reject { |entry| entry["ok"] }.each do |entry|
+              entry["remediation"].each do |line|
+                @output.puts "    fix #{entry['name']}: #{line}"
+              end
+            end
+            checks.reject(&:success?).each do |check|
+              Array(check.respond_to?(:remediation) ? check.remediation : []).each do |line|
+                @output.puts "    fix #{check.name}: #{line}"
+              end
+            end
+          end
+        end
+        payload
+      end
+
+      def bootstrap_qmd
+        prefix = File.join(Hive::Paths.data_home, "qmd")
+        package = ENV.fetch("HIVE_QMD_NPM_PACKAGE", "@tobilu/qmd")
+        FileUtils.mkdir_p(prefix)
+        ok = system(
+          "npm", "install", "--global", "--prefix", prefix,
+          "--no-audit", "--no-fund", package,
+          **(@json ? { out: File::NULL, err: File::NULL } : {})
+        )
+        return false unless ok
+
+        source = File.join(prefix, "bin", "qmd")
+        FileUtils.mkdir_p(Hive::Paths.bin_home)
+        target = File.join(Hive::Paths.bin_home, "qmd")
+        FileUtils.ln_sf(source, target)
+        File.file?(source)
+      end
+
+      def install_bundle
+        require "hive/web/app_bundle"
+        Hive::Web::AppBundle.new(cli_root: cli_root, quiet: @json).install!
+        true
+      end
+
+      def install_daemon(binary)
+        require "hive/commands/daemon/service_installer"
+        outcome = Hive::Commands::Daemon::ServiceInstaller.new(
+          binary_path: binary
+        ).install!(autostart: true, force: true)
+        outcome
+      end
+
+      def daemon_report(binary)
+        require "hive/commands/daemon"
+        require "hive/commands/daemon/service_installer"
+        require "hive/daemon/status_report"
+        command = Hive::Commands::Daemon.new("status")
+        deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + 15
+        loop do
+          report = Hive::Daemon::StatusReport.new(
+            installer: Hive::Commands::Daemon::ServiceInstaller.new(binary_path: binary),
+            pid_probe: command,
+            pid_file: command.pid_file,
+            log_file: command.log_file,
+            current_binary: binary
+          ).to_h
+          return report if report["ready"]
+          return report if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+          sleep 0.25
+        end
+      end
+
+      def enroll_repository
+        unless File.directory?(File.join(@project_root, ".git"))
+          raise Hive::Error,
+                "hive setup: #{@project_root} is not a Git repository; pass --no-init outside a repository"
+        end
+        unless File.directory?(File.join(@project_root, ".hive-state"))
+          require "hive/commands/init"
+          begin
+            suppress_nested_output do
+              Hive::Commands::Init.new(@project_root, force: false, json: false).call
+            end
+          rescue Hive::AlreadyInitialized
+            # The registry/state checks below are the source of truth.
+          end
+        end
+        project = Hive::Config.registered_projects.find do |entry|
+          File.expand_path(entry.fetch("path")) == @project_root
+        end
+        raise Hive::ConfigError, "hive setup: repository enrollment did not register #{@project_root}" unless project
+
+        require "hive/commands/daemon"
+        suppress_nested_output do
+          Hive::Commands::Daemon.new("enable", project.fetch("name")).call
+        end
+        true
+      end
+
+      def install_web(binary)
+        require "hive/commands/web/service_installer"
+        outcome = Hive::Commands::Web::ServiceInstaller.new(
+          binary_path: binary
+        ).install!(autostart: true, force: true)
+        outcome
+      end
+
+      def web_report
+        require "hive/commands/web/service_installer"
+        require "hive/web/service_status"
+        environment = Hive::Web::Environment.new(config: Hive::Config.load_global_web)
+        installer = Hive::Commands::Web::ServiceInstaller.new(binary_path: @binary)
+        deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + 30
+        loop do
+          report = Hive::Web::ServiceStatus.new(installer: installer, url: environment.url).to_h
+          return report if report["ready"]
+          return report if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+          sleep 0.25
+        end
+      end
+
+      def cli_root
+        Gem.loaded_specs["hive-cli"]&.full_gem_path || File.expand_path("../../..", __dir__)
+      end
+
+      def service_fallback?(value)
+        value.respond_to?(:kind) && %i[autostart_unavailable unsupported].include?(value.kind)
+      end
+
+      def suppress_nested_output
+        return yield unless @json
+
+        previous_stdout = $stdout
+        previous_stderr = $stderr
+        $stdout = StringIO.new
+        $stderr = StringIO.new
+        yield
+      ensure
+        $stdout = previous_stdout if previous_stdout
+        $stderr = previous_stderr if previous_stderr
+      end
+    end
+  end
+end
diff --git a/lib/hive/commands/uninstall.rb b/lib/hive/commands/uninstall.rb
index 57f319a2..f7056f0e 100644
--- a/lib/hive/commands/uninstall.rb
+++ b/lib/hive/commands/uninstall.rb
@@ -21,7 +21,15 @@ module Hive
         projects = registered_projects
         deregister_daemon
         deregister_bot
+        web_deregistered = deregister_web
+        unless web_deregistered
+          @output.puts "hive: preserving the web runtime, configuration, and executable links because the web service is still registered"
+          @output.puts "hive: uninstall stopped; fix service-manager state and rerun `hive uninstall`"
+          return 1
+        end
+
         remove_user_config_and_cache
+        remove_web_runtime
         remove_data_versions
         remove_user_symlinks
         cleanup_project_state(projects)
@@ -54,6 +62,19 @@ module Hive
         deregister_unit(Hive::Commands::Bot::ServiceInstaller.new(host_os: @host_os))
       end
 
+      def deregister_web
+        require "hive/commands/web/service_installer"
+        deregister_unit(Hive::Commands::Web::ServiceInstaller.new(host_os: @host_os))
+      end
+
+      def remove_web_runtime
+        return if Hive::Paths.hive_home_collapsed?
+
+        FileUtils.rm_rf(Hive::Paths.web_app_home)
+        FileUtils.rm_rf(Hive::Paths.web_gems_home)
+        FileUtils.rm_rf(Hive::Paths.web_storage_home) if @force_purge_state
+      end
+
       # Deregister a per-user autostart unit using the installer's OWN
       # identity (`target_path` / `service_name`) as the single source of
       # truth, so install and uninstall can never drift on paths or names —
@@ -62,14 +83,14 @@ module Hive
       # failure so one stuck manager never aborts the rest of the uninstall.
       def deregister_unit(installer)
         path = installer.target_path
-        return unless path && File.exist?(path)
+        return true unless path && File.exist?(path)
 
         case @host_os
         when /darwin/i
           ok = @runner.call([ "launchctl", "unload", path ])
           unless ok
             @output.puts "hive: warning: launchctl unload failed for #{path}; leaving it in place. Fix launchd state and re-run `hive uninstall`."
-            return
+            return false
           end
           safe_unlink(path)
         when /linux/i
@@ -77,11 +98,15 @@ module Hive
           ok = @runner.call([ "systemctl", "--user", "disable", "--now", service ])
           unless ok
             @output.puts "hive: warning: systemctl --user disable failed for #{service}; leaving #{path} in place. Fix systemd state and re-run `hive uninstall`."
-            return
+            return false
           end
-          safe_unlink(path)
+          return false unless safe_unlink(path)
+
           ok_reload = @runner.call(%w[systemctl --user daemon-reload])
           @output.puts "hive: warning: systemctl --user daemon-reload failed after removing #{path}; run it manually" unless ok_reload
+          true
+        else
+          true
         end
       end
 
@@ -122,11 +147,12 @@ module Hive
         stat = File.lstat(path)
         if stat.symlink?
           @output.puts "hive: refusing to follow symlink at #{path}; remove it manually"
-          return
+          return false
         end
         FileUtils.rm_f(path)
+        true
       rescue Errno::ENOENT
-        nil
+        true
       end
 
       def remove_user_config_and_cache
diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40f..54fac0ea 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,48 +1,67 @@
 require "hive/config"
+require "hive/invoked_binary"
+require "hive/paths"
+require "hive/web/app_bundle"
+require "hive/web/environment"
 require "hive/web/session_secret"
+require "fileutils"
+require "socket"
+require "json"
 
 module Hive
   module Commands
-    # Boots the hivebox web UI — a Rails app living in web/ at the repo root
-    # (shipped in the Docker image at /app/web). hive itself stays a plain
-    # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # Boots Hive's Rails UI from a source checkout, Docker/hivebox app, or
+    # version-matched managed release bundle. The core CLI gem stays lean.
     class Web
-      def initialize(bind: nil, port: nil)
+      VALID_SUBCOMMANDS = %w[install start stop status].freeze
+
+      def initialize(subcommand = nil, bind: nil, port: nil, unsafe: false,
+                     force: false, json: false)
+        @subcommand = subcommand
         @bind = bind
         @port = port
+        @unsafe = unsafe
+        @force = force
+        @json = json
       end
 
       def call
-        cfg = Hive::Config.load_global_web
-        bind = @bind || cfg.fetch("bind")
-        port = (@port || cfg.fetch("port")).to_i
-        app_dir = rails_app_dir
-        unless app_dir
-          warn "hive web: the hivebox web app (web/) was not found. " \
-               "Run from the hivebox Docker image or a source checkout, " \
-               "or point HIVEBOX_WEB_APP_DIR at the Rails app."
-          exit 1
-        end
+        @stdout_written = false
+        return call_lifecycle if @subcommand
 
-        warn_on_public_bind(bind, cfg)
+        run_foreground
+      rescue Hive::Error => e
+        emit_lifecycle_error(e) if @json && @subcommand && !@stdout_written
+        raise
+      rescue StandardError => e
+        wrapped = Hive::Error.new("hive web: #{e.class}: #{e.message}")
+        emit_lifecycle_error(wrapped) if @json && @subcommand && !@stdout_written
+        raise wrapped
+      end
 
-        env = {
+      private
+
+      def run_foreground
+        cfg = Hive::Config.load_global_web
+        environment = web_environment(cfg)
+        environment.validate_security!
+        ensure_port_available!(environment.bind, environment.port)
+        app_dir = resolve_rails_app_dir
+        env = environment.to_h(
+          app_dir: app_dir,
+          cli_root: cli_root,
+          managed: managed_app?(app_dir)
+        ).merge(
           "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
+          "HIVE_INVOKED_BIN" => current_binary_path,
           # Rails' secret_key_base derives from the same persisted secret the
           # session cookies used pre-Rails, so recreating the container keeps
           # sessions (the file lives on the /data mount).
           "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] ||
-            Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
-          "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
-          # The solid_cable/cache/queue sqlite files must survive image
-          # upgrades — keep them in state_home (on /data in the container),
-          # not in the app dir.
-          "HIVEBOX_STORAGE_DIR" => ENV["HIVEBOX_STORAGE_DIR"] ||
-            File.join(Hive::Paths.state_home, "web-storage"),
-          "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
-        }
-        FileUtils.mkdir_p(env.fetch("HIVEBOX_STORAGE_DIR"))
+            Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file"))
+        )
+        storage_dir = env["HIVE_WEB_STORAGE_DIR"] || File.join(app_dir, "storage")
+        FileUtils.mkdir_p(storage_dir)
 
         Dir.chdir(app_dir) do
           # Idempotent: creates/migrates the solid-stack sqlite databases on
@@ -52,36 +71,236 @@ module Hive
           unless system(env, "bin/rails", "db:prepare")
             raise Hive::Error,
                   "hive web: db:prepare failed — check that " \
-                  "#{env.fetch("HIVEBOX_STORAGE_DIR")} is writable (the /data mount) " \
+                  "#{storage_dir} is writable " \
                   "and that the web bundle is installed (cd #{app_dir} && bundle install)"
           end
-          puts "hive web: listening on http://#{bind}:#{port}"
+          puts "hive web: listening on #{environment.url}"
           # Replace this process with the Rails server (array form, env hash;
           # Kernel#exec never touches a shell when given an argv list).
-          Kernel.exec env, "bin/rails", "server", "-b", bind, "-p", port.to_s
+          Kernel.exec env, "bin/rails", "server", "-b", environment.bind, "-p", environment.port.to_s
         end
       end
 
-      private
+      def call_lifecycle
+        unless VALID_SUBCOMMANDS.include?(@subcommand)
+          raise Hive::InvalidTaskPath,
+                "hive web: unknown subcommand #{@subcommand.inspect} " \
+                "(expected: #{VALID_SUBCOMMANDS.join(', ')})"
+        end
+        case @subcommand
+        when "install" then install_service
+        when "start" then start_service
+        when "stop" then stop_service
+        when "status" then status_service
+        end
+      end
+
+      def install_service
+        Hive::Web::AppBundle.new(cli_root: cli_root, quiet: @json).install!
+        installer = service_installer
+        outcome = installer.install!(autostart: true, force: @force)
+        installer.messages.each { |message| warn "hive: #{message}" } unless @json
+        payload = {
+          "schema" => "hive-web-install",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+          "ok" => outcome.success?,
+          "outcome" => outcome.wire_outcome,
+          "platform" => installer.envelope_platform,
+          "unit_path" => installer.target_path,
+          "backup_path" => outcome.backup_path,
+          "restarted" => outcome.restarted,
+          "url" => configured_environment.url,
+          "messages" => installer.messages
+        }
+        if @json
+          puts JSON.generate(payload)
+          @stdout_written = true
+        end
+        puts "hive web: service #{outcome.wire_outcome} at #{installer.target_path}" unless @json
+        raise Hive::Error, "hive web: service install #{outcome.wire_outcome}" unless outcome.success?
+        payload
+      end
+
+      def start_service
+        installer = service_installer
+        unless installer.service_state["service_installed"]
+          raise Hive::Error, "hive web: service is not installed; run `hive web install`"
+        end
+        raise Hive::Error, "hive web: service manager failed to start hive-web" unless installer.start!
+
+        status = wait_for_readiness(installer)
+        emit_status(status, operation: "start", ok: status["ready"])
+        raise Hive::Error, "hive web: service started but /health did not become ready" unless status["ready"]
+        status
+      end
+
+      def stop_service
+        installer = service_installer
+        raise Hive::Error, "hive web: service manager failed to stop hive-web" unless installer.stop!
+
+        status = service_status(installer).to_h
+        emit_status(status, operation: "stop", ok: true)
+        status
+      end
+
+      def status_service
+        status = service_status(service_installer).to_h
+        emit_status(status, operation: "status", ok: status["ready"])
+        raise Hive::Error, "web service is not ready (#{status['failure']})" unless status["ready"]
+        status
+      end
+
+      def emit_status(status, operation:, ok:)
+        payload = {
+          "schema" => "hive-web-status",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"),
+          "ok" => ok,
+          "operation" => operation
+        }.merge(status)
+        if @json
+          puts JSON.generate(payload)
+          @stdout_written = true
+        else
+          state = status["ready"] ? "ready" : (status["running"] ? "running, not ready" : "stopped")
+          puts "hive web: #{state} — #{status['url']}"
+          warn "hive web: #{status['failure']}" if status["failure"]
+          warn "hive web: UNSAFE non-loopback service exposure" if status["unsafe"]
+        end
+      end
+
+      def emit_lifecycle_error(error)
+        if @subcommand == "install"
+          metadata = safe_installer_metadata
+          payload = {
+            "schema" => "hive-web-install",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+            "ok" => false,
+            "outcome" => "failed",
+            "platform" => metadata.fetch("platform"),
+            "unit_path" => metadata["unit_path"],
+            "backup_path" => nil,
+            "restarted" => false,
+            "url" => safe_configured_url,
+            "messages" => [ error.message ]
+          }
+        else
+          payload = {
+            "schema" => "hive-web-status",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"),
+            "ok" => false,
+            "operation" => @subcommand,
+            "platform" => nil,
+            "unit_path" => nil,
+            "service_installed" => nil,
+            "service_enabled" => nil,
+            "running" => false,
+            "ready" => false,
+            "url" => safe_configured_url,
+            "desired_url" => safe_configured_url,
+            "configuration_drift" => false,
+            "unsafe" => @unsafe == true,
+            "failure" => "command_failed",
+            "message" => error.message
+          }
+        end
+        puts JSON.generate(payload)
+        @stdout_written = true
+      end
+
+      def safe_installer_metadata
+        installer = service_installer
+        {
+          "platform" => installer.envelope_platform,
+          "unit_path" => installer.target_path
+        }
+      rescue StandardError
+        { "platform" => "unsupported", "unit_path" => nil }
+      end
+
+      def safe_configured_url
+        configured_environment.url
+      rescue StandardError
+        bind = @bind.to_s.empty? ? "127.0.0.1" : @bind
+        port = @port || 4567
+        host = bind == "::1" ? "[::1]" : bind
+        "http://#{host}:#{port}"
+      end
+
+      def wait_for_readiness(installer, timeout: 30)
+        deadline = Process.clock_gettime(Process::CLOCK_MONOTONIC) + timeout
+        loop do
+          status = service_status(installer).to_h
+          return status if status["ready"]
+          return status if Process.clock_gettime(Process::CLOCK_MONOTONIC) >= deadline
+          sleep 0.25
+        end
+      end
+
+      def service_installer
+        require "hive/commands/web/service_installer"
+        Hive::Commands::Web::ServiceInstaller.new(
+          binary_path: current_binary_path,
+          bind: @bind,
+          port: @port,
+          unsafe: @unsafe
+        )
+      end
+
+      def service_status(installer)
+        require "hive/web/service_status"
+        Hive::Web::ServiceStatus.new(installer: installer, url: configured_environment.url)
+      end
+
+      def configured_environment
+        web_environment(Hive::Config.load_global_web)
+      end
 
       def rails_app_dir
         candidates = [
+          ENV["HIVE_WEB_APP_DIR"],
           ENV["HIVEBOX_WEB_APP_DIR"],
-          File.expand_path("../../../web", __dir__)
+          File.expand_path("../../../web", __dir__),
+          Hive::Paths.web_app_home
         ].compact
         candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
       end
 
-      # Rails' production host authorization is inactive by default — the box
-      # assumes a trusted reverse proxy validates Host, exactly like the
-      # pre-Rails posture. Binding a public interface without that proxy
-      # exposes the app to DNS-rebinding / Host-injection, so make it loud.
-      def warn_on_public_bind(bind, cfg)
-        return unless bind.to_s == "0.0.0.0"
-        return if cfg["origin"].to_s.start_with?("https://")
+      def resolve_rails_app_dir
+        rails_app_dir || Hive::Web::AppBundle.new(cli_root: cli_root, quiet: @json).install!
+      rescue Hive::Error
+        raise
+      rescue StandardError => e
+        raise Hive::Error, "hive web: could not install the matching Rails bundle: #{e.message}"
+      end
+
+      def web_environment(cfg)
+        Hive::Web::Environment.new(
+          config: cfg, bind: @bind, port: @port, unsafe: @unsafe
+        )
+      end
+
+      def cli_root
+        spec = Gem.loaded_specs["hive-cli"]
+        spec ? spec.full_gem_path : File.expand_path("../../..", __dir__)
+      end
+
+      def current_binary_path
+        Hive::InvokedBinary.path || File.expand_path("../../../bin/hive", __dir__)
+      end
+
+      def managed_app?(app_dir)
+        File.expand_path(app_dir) == File.expand_path(Hive::Paths.web_app_home)
+      end
 
-        warn "hive web: WARNING binding 0.0.0.0 without an https origin — " \
-             "ensure a trusted reverse proxy validates the Host header."
+      def ensure_port_available!(bind, port)
+        server = TCPServer.new(bind, port)
+        server.close
+      rescue Errno::EADDRINUSE
+        raise Hive::Error,
+              "hive web: #{bind}:#{port} is already in use; stop the conflicting process " \
+              "or choose another port with --port"
+      rescue SocketError, SystemCallError => e
+        raise Hive::Error, "hive web: cannot bind #{bind}:#{port}: #{e.message}"
       end
     end
   end
